package org.hybird.scenile.core.converters;

/*
* Scenile v0.1 - January 09
* Author: Rmy Rakic
* URL: http://lqd.hybird.org
*  
* License: BSD/GPL
* - If you use scenario 0.6 directly and can comply to its GPL license,
*  you can use this library under the GPL.
* - If you use scenario 1.0+ by depending on the javafx runtime,
*  you can use this library under the following modified BSD license. 
*
* Copyright 2009 Rmy Rakic.  All Rights Reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions
* are met:
*
*   - Redistributions of source code must retain the above copyright
*     notice, this list of conditions and the following disclaimer.
*
*   - Redistributions in binary form must reproduce the above copyright
*     notice, this list of conditions and the following disclaimer in the
*     documentation and/or other materials provided with the distribution.
*
*   - Neither the name of Rmy Rakic nor the names of its
*     contributors may be used to endorse or promote products derived
*     from this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
* IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
* THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
* PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
* CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
* EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
* PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
* PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
* LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
* NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
* SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/* That's an ugly one :) */ 
class CompoundPropertyConverter <T, U> implements ICompoundConverter<T>
{
   @Override @SuppressWarnings("unchecked")
   public final T convert (Object... values)
   {
      switch (values.length)
      {
         case 1: return convert ((U) values[0]);
         case 2: return convert ((U) values[0], (U) values[1]);
         case 3: return convert ((U) values[0], (U) values[1], (U) values[2]);
         case 4: return convert ((U) values[0], (U) values[1], (U) values[2], (U) values[3]);
         case 5: return convert ((U) values[0], (U) values[1], (U) values[2], (U) values[3], (U) values[4]);
         default: throw new PropertyConversionNotSupportedException (values.length);
      }
   }
   
   protected T convert (U value)
   {
      throw new PropertyConversionNotSupportedException (1);
   }
   
   protected T convert (U value1, U value2)
   {
      throw new PropertyConversionNotSupportedException (2);
   }
   
   protected T convert (U value1, U value2, U value3)
   {
      throw new PropertyConversionNotSupportedException (3);
   }
   
   protected T convert (U value1, U value2, U value3, U value4)
   {
      throw new PropertyConversionNotSupportedException (4);
   }
   
   protected T convert (U value1, U value2, U value3, U value4, U value5)
   {
      throw new PropertyConversionNotSupportedException (5);
   }
   
   public static class PropertyConversionNotSupportedException extends IllegalArgumentException
   {
      public PropertyConversionNotSupportedException (int count)
      {
         super ("The property conversion for " + count + " parameter(s) should have been implemented !");
      }
   }
}